
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 09/09/2013 13:06:31
-- Generated from EDMX file: D:\Projects\_academy\ClassLibrary2\ClassLibrary2\AcademyModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [master];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------


-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------


-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Username] nvarchar(max)  NOT NULL,
    [Password] nvarchar(max)  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [DateOfBirth] datetime  NOT NULL
);
GO

-- Creating table 'Courses'
CREATE TABLE [dbo].[Courses] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Description] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Materials'
CREATE TABLE [dbo].[Materials] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Description] nvarchar(max)  NOT NULL,
    [CourseId] int  NOT NULL
);
GO

-- Creating table 'Problems'
CREATE TABLE [dbo].[Problems] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Description] nvarchar(max)  NOT NULL,
    [CourseId] int  NOT NULL
);
GO

-- Creating table 'CourseLecturers'
CREATE TABLE [dbo].[CourseLecturers] (
    [Lecturers_Id] int  NOT NULL,
    [LecturedCourses_Id] int  NOT NULL
);
GO

-- Creating table 'CourseParticipants'
CREATE TABLE [dbo].[CourseParticipants] (
    [Participants_Id] int  NOT NULL,
    [Courses_Id] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Courses'
ALTER TABLE [dbo].[Courses]
ADD CONSTRAINT [PK_Courses]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Materials'
ALTER TABLE [dbo].[Materials]
ADD CONSTRAINT [PK_Materials]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Problems'
ALTER TABLE [dbo].[Problems]
ADD CONSTRAINT [PK_Problems]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Lecturers_Id], [LecturedCourses_Id] in table 'CourseLecturers'
ALTER TABLE [dbo].[CourseLecturers]
ADD CONSTRAINT [PK_CourseLecturers]
    PRIMARY KEY NONCLUSTERED ([Lecturers_Id], [LecturedCourses_Id] ASC);
GO

-- Creating primary key on [Participants_Id], [Courses_Id] in table 'CourseParticipants'
ALTER TABLE [dbo].[CourseParticipants]
ADD CONSTRAINT [PK_CourseParticipants]
    PRIMARY KEY NONCLUSTERED ([Participants_Id], [Courses_Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Lecturers_Id] in table 'CourseLecturers'
ALTER TABLE [dbo].[CourseLecturers]
ADD CONSTRAINT [FK_CourseLecturers_User]
    FOREIGN KEY ([Lecturers_Id])
    REFERENCES [dbo].[Users]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [LecturedCourses_Id] in table 'CourseLecturers'
ALTER TABLE [dbo].[CourseLecturers]
ADD CONSTRAINT [FK_CourseLecturers_Course]
    FOREIGN KEY ([LecturedCourses_Id])
    REFERENCES [dbo].[Courses]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CourseLecturers_Course'
CREATE INDEX [IX_FK_CourseLecturers_Course]
ON [dbo].[CourseLecturers]
    ([LecturedCourses_Id]);
GO

-- Creating foreign key on [Participants_Id] in table 'CourseParticipants'
ALTER TABLE [dbo].[CourseParticipants]
ADD CONSTRAINT [FK_CourseParticipants_User]
    FOREIGN KEY ([Participants_Id])
    REFERENCES [dbo].[Users]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Courses_Id] in table 'CourseParticipants'
ALTER TABLE [dbo].[CourseParticipants]
ADD CONSTRAINT [FK_CourseParticipants_Course]
    FOREIGN KEY ([Courses_Id])
    REFERENCES [dbo].[Courses]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CourseParticipants_Course'
CREATE INDEX [IX_FK_CourseParticipants_Course]
ON [dbo].[CourseParticipants]
    ([Courses_Id]);
GO

-- Creating foreign key on [CourseId] in table 'Materials'
ALTER TABLE [dbo].[Materials]
ADD CONSTRAINT [FK_CourseMaterial]
    FOREIGN KEY ([CourseId])
    REFERENCES [dbo].[Courses]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CourseMaterial'
CREATE INDEX [IX_FK_CourseMaterial]
ON [dbo].[Materials]
    ([CourseId]);
GO

-- Creating foreign key on [CourseId] in table 'Problems'
ALTER TABLE [dbo].[Problems]
ADD CONSTRAINT [FK_CourseProblem]
    FOREIGN KEY ([CourseId])
    REFERENCES [dbo].[Courses]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CourseProblem'
CREATE INDEX [IX_FK_CourseProblem]
ON [dbo].[Problems]
    ([CourseId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------