﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace David.Academy.InformationTechnology.AcademyModel
{
	class TestModel
	{
		/// <summary>
		/// Връща информация за потребител по подаден идентификатор
		/// </summary>
		/// <param name="userId">идентификатор на потребителя</param>
		/// <returns>информация за потребител</returns>
		public User GetUser(int userId)
		{
			using (AcademyModelContainer container = new AcademyModelContainer())
			{
				return GetUser(container, userId);
			}
		}

		public int AddUser(User user)
		{
			using (AcademyModelContainer container = new AcademyModelContainer())
			{
				User dbUser = new User();
				dbUser.Username = user.Username;
				dbUser.Password = user.Password;
				dbUser.Name = user.Name;
				dbUser.DateOfBirth = user.DateOfBirth;
				// TODO: ...

				container.Users.Add(user);

				container.SaveChanges();

				return dbUser.Id;
			}
		}

		public void UpdateUser(int userId, User user)
		{
			using (AcademyModelContainer container = new AcademyModelContainer())
			{
				User dbUser = GetUser(container, userId);
				dbUser.Name = user.Name;
				dbUser.DateOfBirth = user.DateOfBirth;
				// TODO: ...

				container.SaveChanges();
			}
		}

		public void RemoveUser(int userId)
		{
			using (AcademyModelContainer container = new AcademyModelContainer())
			{
				User dbUser = GetUser(container, userId);

				container.Users.Remove(dbUser);

				container.SaveChanges();
			}
		}

		private static User GetUser(AcademyModelContainer container, int userId)
		{
			IEnumerable<User> users = from u in container.Users
									  where u.Id == userId
									  select u;

			User user = users.FirstOrDefault();
			if (user == null)
				throw new Exception("No such user.");

			return user;
		}
	}
}
