﻿using System.Web.Mvc;
using David.Academy.InformationTechnology.MvcDynamicApp.Models;

namespace David.Academy.InformationTechnology.MvcDynamicApp.Controllers
{
	public class SessionController : Controller
	{
		//
		// GET: /Session/LogIn/
		[HttpGet]
		public ActionResult LogIn()
		{
			SessionModel model = new SessionModel();

			return View(model);
		}

		//
		// POST: /Session/LogIn/
		[HttpPost]
		public ActionResult LogIn(SessionModel model)
		{
			if (!model.IsValidLogIn())
			{
				return View(model);
			}

			// добавяме към сесията информация за влезлия потребител
			Session["UserId"] = model.GetUserId();

			// препращаме потребителя към първоначалната страница
			return RedirectToAction("Index", "Home");
		}

		//
		// GET: /Session/LogIn/
		public ActionResult LogOut()
		{
			// махаме от сесията информацията за влезлия потребител
			Session["UserId"] = null;

			// препращаме потребителя към първоначалната страница
			return RedirectToAction("Index", "Home");
		}
	}
}
